/* 
 * $TSUKUBA_Release: Omni Compiler Version 0.9.1 $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010-2014 University of Tsukuba, 
 *  	      2012-2014  University of Tsukuba and Riken AICS
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  * The specification of XcalableMP has been designed by the XcalableMP
 *    Specification Working Group (http://www.xcalablemp.org/).
 *  
 *  * The development of this software was partially supported by "Seamless and
 *    Highly-productive Parallel Programming Environment for
 *    High-performance computing" project funded by Ministry of Education,
 *    Culture, Sports, Science and Technology, Japan.
 *  $
 */

package exc.xmpF;

import exc.object.*;
import exc.block.*;

/**
 * XcalableMP AST translator (for Coarray)
 */
public class XMPtransCoarray implements XobjectDefVisitor
{
  XMPenv env;
  private int pass;


  //-----------------------------------------
  //  constructor
  //-----------------------------------------

  public XMPtransCoarray() {
    this(null, 1);
  }
  public XMPtransCoarray(XobjectFile env) {
    this(env, 1);
  }
  public XMPtransCoarray(XobjectFile env, int pass) {
    this.env = new XMPenv(env);
    this.pass = pass;
  }

  public void setPass(int pass) {
    this.pass = pass;
  }

  //  public void init(XobjectFile env) {
  //    this.env = new XMPenv(env);
  //}
    
  public void finish() {
    env.finalize();
  }
    

  //-----------------------------------------
  //  do transform (called topdown, twice)
  //-----------------------------------------

  public void doDef(XobjectDef d) {
    FuncDefBlock fd;
    Boolean is_module = d.isFmoduleDef();
    XMPtransCoarrayRun transCoarrayRun;

    if (pass == 1 && !is_module) {
      //fd = new FuncDefBlock(d);
      XMP.resetError();
      //transCoarrayRun = new XMPtransCoarrayRun(fd, env);
      transCoarrayRun = new XMPtransCoarrayRun(d, env, 1);
      transCoarrayRun.run1();
      //fd.Finalize();
    } else if (pass == 2 && is_module) {
      //fd = new FuncDefBlock(d);
      //fd = XMPmoduleBlock(d);         // referred to XMPtranslate.doDef
      XMP.resetError();
      //transCoarrayRun = new XMPtransCoarrayRun(fd, env);
      transCoarrayRun = new XMPtransCoarrayRun(d, env, 2);
      //***transCoarrayRun.run2();
      //fd.Finalize();
    } else {
      return;
    }

    if(XMP.hasError())
      return;
  }

}

